const add = (x,y,cb)=>{
    setTimeout(()=>{
        cb(x+y)
    }, 2000)
}

add(1,2, x=>console.log(x))

add(1,2, sum1 =>{
    add(sum1, 3, sum2 =>{
        add(sum2, 4, sum3=> {
            console.log('Result:'+sum3)
        })
    } )
})


const addPromise = (a,b) => {
    return new Promise((resolve,reject)=>{
        setTimeout(()=>{
            resolve(a+b),100
        })
    })    
}

addPromise(1,2)
    .then( (sum1) => {
        return addPromise(3, sum1)
    })
    .then( (sum2) =>{
        return addPromise(4, sum2)
    })
    .then( sum3 =>{ console.log('Sum: '+sum3)
})


